
//	GEF includes
#include "GEFInput.hh"

//	C++ includes
#include <iostream>

ClassImp( GEFInput )

///	------++++++------++++++------++++++------++++++------
///					GEFInput()
///	------++++++------++++++------++++++------++++++------
GEFInput::GEFInput() : TObject()
{
	name = "";
	outputDir = "";
	numComponents = -1;
	sourceActivity = 0;
	numDecays = -1;
}

///	------++++++------++++++------++++++------++++++------
///					~GEFInput()
///	------++++++------++++++------++++++------++++++------
GEFInput::~GEFInput()
{
	if( compName ) delete [] compName;
	if( compMaterial ) delete [] compMaterial;
	if( compShape ) delete [] compShape;
	if( compBoxX ) delete [] compBoxX;
	if( compBoxY ) delete [] compBoxY;
	if( compBoxZ ) delete [] compBoxZ;
	if( compCylHeight ) delete [] compCylHeight;
	if( compCylRadius ) delete [] compCylRadius;
	if( compPosX ) delete [] compPosX;
	if( compPosY ) delete [] compPosY;
	if( compPosZ ) delete [] compPosZ;
	if( compRotX ) delete [] compRotX;
	if( compRotY ) delete [] compRotY;
	if( compRotZ ) delete [] compRotZ;
	if( actMaterial ) delete [] actMaterial;
	if( actShape ) delete [] actShape;
	if( actBoxX ) delete [] actBoxX;
	if( actBoxY ) delete [] actBoxY;
	if( actBoxZ ) delete [] actBoxZ;
	if( actCylHeight ) delete [] actCylHeight;
	if( actCylRadius ) delete [] actCylRadius;
	if( actPosX ) delete [] actPosX;
	if( actPosY ) delete [] actPosY;
	if( actPosZ ) delete [] actPosZ;
	if( actRotX ) delete [] actRotX;
	if( actRotY ) delete [] actRotY;
	if( actRotZ ) delete [] actRotZ;
}

///	------++++++------++++++------++++++------++++++------
///					GEFInput::BuildTree()
///	------++++++------++++++------++++++------++++++------
void GEFInput::BuildLeaves( Int_t num )
{
	numComponents = num;
	if( numComponents < 0 ) {
		std::cout << std::endl << std::endl;
		std::cout << "Big problem! Can't allocate the event arrays because the "
			   << "number of particles is" << std::endl
			   << "not yet set!" << std::endl;
		exit( 0 );
	}
	
	compName = new TString[numComponents];
	compMaterial = new TString[numComponents];
	compShape = new TString[numComponents];
	compBoxX = new Double_t[numComponents];
	compBoxY = new Double_t[numComponents];
	compBoxZ = new Double_t[numComponents];
	compCylHeight = new Double_t[numComponents];
	compCylRadius = new Double_t[numComponents];
	compPosX = new Double_t[numComponents];
	compPosY = new Double_t[numComponents];
	compPosZ = new Double_t[numComponents];
	compRotX = new Double_t[numComponents];
	compRotY = new Double_t[numComponents];
	compRotZ = new Double_t[numComponents];
	actMaterial = new TString[numComponents];
	actShape = new TString[numComponents];
	actBoxX = new Double_t[numComponents];
	actBoxY = new Double_t[numComponents];
	actBoxZ = new Double_t[numComponents];
	actCylHeight = new Double_t[numComponents];
	actCylRadius = new Double_t[numComponents];
	actPosX = new Double_t[numComponents];
	actPosY = new Double_t[numComponents];
	actPosZ = new Double_t[numComponents];
	actRotX = new Double_t[numComponents];
	actRotY = new Double_t[numComponents];
	actRotZ = new Double_t[numComponents];
}

///	------++++++------++++++------++++++------++++++------
///					GEFInput::ClearTree()
///	------++++++------++++++------++++++------++++++------
void GEFInput::ClearLeaves()
{
	name = "";
	outputDir = "";
	numComponents = -1;
	sourceActivity = 0;
	numDecays = -1;
	if( compName ) delete [] compName;
	if( compMaterial ) delete [] compMaterial;
	if( compShape ) delete [] compShape;
	if( compBoxX ) delete [] compBoxX;
	if( compBoxY ) delete [] compBoxY;
	if( compBoxZ ) delete [] compBoxZ;
	if( compCylHeight ) delete [] compCylHeight;
	if( compCylRadius ) delete [] compCylRadius;
	if( compPosX ) delete [] compPosX;
	if( compPosY ) delete [] compPosY;
	if( compPosZ ) delete [] compPosZ;
	if( compRotX ) delete [] compRotX;
	if( compRotY ) delete [] compRotY;
	if( compRotZ ) delete [] compRotZ;
	if( actMaterial ) delete [] actMaterial;
	if( actShape ) delete [] actShape;
	if( actBoxX ) delete [] actBoxX;
	if( actBoxY ) delete [] actBoxY;
	if( actBoxZ ) delete [] actBoxZ;
	if( actCylHeight ) delete [] actCylHeight;
	if( actCylRadius ) delete [] actCylRadius;
	if( actPosX ) delete [] actPosX;
	if( actPosY ) delete [] actPosY;
	if( actPosZ ) delete [] actPosZ;
	if( actRotX ) delete [] actRotX;
	if( actRotY ) delete [] actRotY;
	if( actRotZ ) delete [] actRotZ;
}

