
//	GEF includes
#include "GEFOutput.hh"

//	C++ includes
#include <iostream>

ClassImp( GEFOutput )

///	------++++++------++++++------++++++------++++++------
///					GEFOutput()
///	------++++++------++++++------++++++------++++++------
GEFOutput::GEFOutput() : TObject()
{
	event = -1;
	numParticles = -1;
	eventTime = -1;
}

///	------++++++------++++++------++++++------++++++------
///					~GEFOutput()
///	------++++++------++++++------++++++------++++++------
GEFOutput::~GEFOutput()
{
	if( particle ) delete [] particle;
	if( energy ) delete [] energy;
	if( depTime ) delete [] depTime;
	if( volume ) delete [] volume;
	if( volumeLocX ) delete [] volumeLocX;
	if( volumeLocY ) delete [] volumeLocY;
	if( volumeLocZ ) delete [] volumeLocZ;
	if( worldLocX ) delete [] worldLocX;
	if( worldLocY ) delete [] worldLocY;
	if( worldLocZ ) delete [] worldLocZ;
	if( preProc ) delete [] preProc;
	if( postProc ) delete [] postProc;
	if( trackID ) delete [] trackID;
	if( parentID ) delete [] parentID;
	if( creationProc ) delete [] creationProc;
	if( creationLocX ) delete [] creationLocX;
	if( creationLocY ) delete [] creationLocY;
	if( creationLocZ ) delete [] creationLocZ;
}

///	------++++++------++++++------++++++------++++++------
///					GEFOutput::BuildTree()
///	------++++++------++++++------++++++------++++++------
void GEFOutput::BuildLeaves( Int_t num )
{
	numParticles = num;
	if( numParticles < 0 ) {
		std::cout << std::endl << std::endl;
		std::cout << "Big problem! Can't allocate the event arrays because the "
			   << "number of particles is" << std::endl
			   << "not yet set!" << std::endl;
		exit( 0 );
	}
	
	particle = new TString[numParticles];
	energy = new Double_t[numParticles];
	depTime = new Double_t[numParticles];
	volume = new TString[numParticles];
	volumeLocX = new Double_t[numParticles];
	volumeLocY = new Double_t[numParticles];
	volumeLocZ = new Double_t[numParticles];
	worldLocX = new Double_t[numParticles];
	worldLocY = new Double_t[numParticles];
	worldLocZ = new Double_t[numParticles];
	preProc = new TString[numParticles];
	postProc = new TString[numParticles];
	trackID = new Int_t[numParticles];
	parentID = new Int_t[numParticles];
	creationProc = new TString[numParticles];
	creationLocX = new Double_t[numParticles];
	creationLocY = new Double_t[numParticles];
	creationLocZ = new Double_t[numParticles];
}

///	------++++++------++++++------++++++------++++++------
///					GEFOutput::ClearTree()
///	------++++++------++++++------++++++------++++++------
void GEFOutput::ClearLeaves()
{
	event = -1;
	numParticles = -1;
	eventTime = -1;
	if( particle ) delete [] particle;
	if( energy ) delete [] energy;
	if( depTime ) delete [] depTime;
	if( volume ) delete [] volume;
	if( volumeLocX ) delete [] volumeLocX;
	if( volumeLocY ) delete [] volumeLocY;
	if( volumeLocZ ) delete [] volumeLocZ;
	if( worldLocX ) delete [] worldLocX;
	if( worldLocY ) delete [] worldLocY;
	if( worldLocZ ) delete [] worldLocZ;
	if( preProc ) delete [] preProc;
	if( postProc ) delete [] postProc;
	if( trackID ) delete [] trackID;
	if( parentID ) delete [] parentID;
	if( creationProc ) delete [] creationProc;
	if( creationLocX ) delete [] creationLocX;
	if( creationLocY ) delete [] creationLocY;
	if( creationLocZ ) delete [] creationLocZ;
}

